<?php /*>*/ if (!defined('PmWiki')) exit();
/* CodeMirror - An enhanced page editor for PmWiki
 * Please refer to the main source module for copyright and license info.
 * Latest required version: 2019-07-24
 *
 * Quick'n dirty SourceBlock recipe compatibility extension
 */

if (!isset($RecipeInfo['CodeMirror'])
	|| !IsEnabled($EnableCodeMirrorBlockMarkup)
	|| !function_exists('CodeMirrorBlock'))
	Abort('?cm-sourceblock-compat require CodeMirror with $EnableCodeMirrorBlockMarkup enabled');

SDVA($CodeMirrorSourceBlockCompatibleModes, array(
#'4cs' => '',
#'6502acme' => '',
#'6502kickass' => '',
#'6502tasm' => '',
#'68000devpac' => '',
#'abap' => '',
#'actionscript' => '',
#'actionscript3' => '',
#'ada' => '',
#'aimms' => '',
#'algol68' => '',
#'apache' => '',
#'applescript' => '',
#'apt_sources' => '',
#'arm' => '',
#'asm' => '',
	'asp' => 'application/x-aspx',
#'asymptote' => '',
#'autoconf' => '',
#'autohotkey' => '',
#'autoit' => '',
#'avisynth' => '',
#'awk' => '',
#'bascomavr' => '',
	'bash' => 'text/x-sh',
#'basic4gl' => '',
#'batch' => '',
#'bf' => '',
#'biblatex' => '',
#'bibtex' => '',
#'blitzbasic' => '',
	'bnf' => 'text/x-ebnf',
#'boo' => '',
	'c' => 'text/x-csrc',
	'c_loadrunner' => 'text/x-csrc',
	'c_mac' => 'text/x-csrc',
	'c_winapi' => 'text/x-csrc',
#'caddcl' => '',
	'cadlisp' => 'text/x-common-lisp',
#'ceylon' => '',
#'cfdg' => '',
#'cfm' => '',
#'chaiscript' => '',
#'chapel' => '',
#'cil' => '',
	'closure' => 'text/x-clojure',
	'cmake' => 'text/x-cmake',
#'cobol' => '',
	'coffeescript' => 'text/x-coffeescript',
	'cpp' => 'text/x-c++src',
	'cpp-qt' => 'text/x-c++src',
	'cpp-winapi' => 'text/x-c++src',
	'csharp' => 'text/x-csharp',
	'css' => 'text/css',
#'cuesheet' => '',
	'd' => 'text/x-d',
	'dart' => 'text/x-dart',
#'dcl' => '',
#'dcpu16' => '',
#'dcs' => '',
	'delphi' => 'text/x-pascal',
	'diff' => 'text/x-diff',
#'div' => '',
#'dos' => '',
#'dot' => '',
#'e' => '',
	'ecmascript' => 'text/ecmascript',
	'eiffel' => 'text/x-eiffel',
#'email' => '',
#'epc' => '',
	'erlang' => 'text/x-erlang',
#'euphoria' => '',
#'ezt' => '',
#'f1' => '',
#'falcon' => '',
#'fo' => '',
	'fortran' => 'text/x-fortran',
#'freebasic' => '',
#'freeswitch' => '',
	'fsharp' => 'text/x-fsharp',
#'gambas' => '',
#'gdb' => '',
#'genero' => '',
#'genie' => '',
#'gettext' => '',
#'glsl' => '',
#'gml' => '',
#'gnuplot' => '',
	'go' => '	text/x-go',
	'groovy' => 'text/x-groovy',
#'gwbasic' => '',
	'haskell' => 'text/x-haskell',
	'haxe' => 'text/x-haxe',
#'hicest' => '',
#'hq9plus' => '',
	'html4strict' => 'text/html',
	'html5' => 'text/html',
#'icon' => '',
	'idl' => 'text/x-idl',
	'ini' => 'text/x-ini',
#'inno' => '',
#'intercal' => '',
#'io' => '',
#'ispfpanel' => '',
#'j' => '',
	'java' => 'text/x-java',
	'java5' => 'text/x-java',
	'javascript' => 'application/x-javascript',
#'jcl' => '',
	'jquery' => 'application/x-javascript',
	'julia' => 'text/x-julia',
#'kixtart' => '',
#'klonec' => '',
#'klonecpp' => '',
#'kotlin' => '',
#'latex' => '',
#'lb' => '',
#'ldif' => '',
	'lisp' => 'text/x-common-lisp',
#'llvm' => '',
#'locobasic' => '',
#'logtalk' => '',
#'lolcode' => '',
#'lotusformulas' => '',
#'lotusscript' => '',
#'lscript' => '',
#'lsl2' => '',
	'lua' => 'text/x-lua',
#'m68k' => '',
#'magiksf' => '',
#'make' => '',
#'mapbasic' => '',
	'mathematica' => 'text/x-mathematica',
#'matlab' => '',
#'mercury' => '',
#'metapost' => '',
	'mirc' => 'text/mirc',
#'mk-61' => '',
#'mmix' => '',
#'modula2' => '',
#'modula3' => '',
#'mpasm' => '',
#'mxml' => '',
	'mysql' => 'text/x-mysql',
#'nagios' => '',
#'netrexx' => '',
	'newlisp' => 'text/x-common-lisp',
	'nginx' => 'text/x-nginx-conf',
#'nimrod' => '',
	'nsis' => 'text/x-nsis',
#'oberon2' => '',
	'objc' => 'text/x-objectivec',
#'objeck' => '',
	'ocaml' => 'text/x-ocaml',
	'ocaml-brief' => 'text/x-ocaml',
	'octave' => 'text/x-octave',
#'oobas' => '',
#'oorexx' => '',
	'oracle11' => 'text/x-plsql',
	'oracle8' => 'text/x-plsql',
#'oxygene' => '',
	'oz' => 'text/x-oz',
#'parasail' => '',
#'parigp' => '',
	'pascal' => 'text/x-pascal',
#'pcre' => '',
#'per' => '',
	'perl' => 'text/x-perl',
	'perl6' => 'text/x-perl',
#'pf' => '',
#'phix' => '',
	'php' => 'text/x-php',
	'php-brief' => 'text/x-php',
#'pic16' => '',
#'pike' => '',
#'pixelbender' => '',
#'pli' => '',
	'plsql' => 'text/x-plsql',
	'postgresql' => 'text/x-pgsql',
#'postscript' => '',
#'povray' => '',
#'powerbuilder' => '',
	'powershell' => 'application/x-powershell',
#'proftpd' => '',
#'progress' => '',
#'prolog' => '',
	'properties' => 'text/x-properties',
#'providex' => '',
#'purebasic' => '',
	'pycon' => 'text/x-python',
#'pys60' => '',
	'python' => 'text/x-python',
	'q' => 'text/x-q',
#'qbasic' => '',
#'qml' => '',
#'racket' => '',
	'rails' => 'text/x-ruby',
#'rbs' => '',
#'rebol' => '',
#'reg' => '',
#'rexx' => '',
#'robots' => '',
	'rpmspec' => 'text/x-rpm-spec',
#'rsplus' => '',
	'ruby' => 'text/x-ruby',
	'rust' => 'text/x-rustsrc',
	'sas' => 'text/x-sas',
	'sass' => 'text/x-sass',
	'scala' => 'text/x-scala',
	'scheme' => 'text/x-scheme',
#'scilab' => '',
#'scl' => '',
#'sdlbasic' => '',
	'smalltalk' => 'text/x-stsrc',
	'smarty' => 'text/x-smarty',
#'spark' => '',
	'sparql' => 'application/sparql-query',
	'sql' => 'text/x-sql',
#'standardml' => '',
#'stonescript' => '',
	'swift' => 'text/x-swift',
	'systemverilog' => 'text/x-systemverilog',
	'tcl' => 'text/x-tcl',
#'tclegg' => '',
#'teraterm' => '',
#'texgraph' => '',
	'text' => 'text/plain',
#'thinbasic' => '',
	'tsql' => 'text/x-mssql',
	'twig' => 'text/x-twig',
#'typoscript' => '',
#'unicon' => '',
#'upc' => '',
#'urbi' => '',
#'uscript' => '',
#'vala' => '',
	'vb' => 'text/x-vb',
	'vbnet' => 'text/x-vb',
	'vbscript' => 'text/vbscript',
#'vedit' => '',
	'verilog' => 'text/x-verilog',
	'vhdl' => 'text/x-vhdl',
#'vim' => '',
#'visualfoxpro' => '',
#'visualprolog' => '',
#'whitespace' => '',
#'whois' => '',
#'winbatch' => '',
#'xbasic' => '',
#'xml' => '',
#'xojo' => '',
#'xorg_conf' => '',
#'xpp' => '',
#'xyscript' => '',
	'yaml' => 'text/x-yaml',
	'z80' => 'text/x-z80',
#'zxbasic' => '',
));

Markup('cmsblock', '>markupend',
  "/\\(:source(\\s+([^\n]*?))?\\s*:\)[^\\S\n]*\\[([=@])(.*?)\\3\\]/si",
  "CodeMirrorSourceBlockMarkup");
Markup('cmsblockend', '>cmsblock',
  "/\\(:(source)(\\s+([^\n]*?))?\\s*:\)[^\\S\n]*\n(.*?)\\(:sourcee?nd:\\)/si",
  "CodeMirrorSourceBlockMarkup");
function CodeMirrorSourceBlockMarkup($m) {
  extract($GLOBALS['MarkupToHTML']);
  global $CodeMirrorSourceBlockCompatibleModes, $CodeMirrorModeSpecs;

  VarDump($m, '$m');
  $opt = ParseArgs($m[2]);
  $spec = isset($opt['lang']) ?
  	$CodeMirrorSourceBlockCompatibleModes[$opt['lang']] : 'text/plain';
  $linenum = isset($opt['linenum']) ? $opt['linenum'] : (@in_array('linenum', $opt['']) ? 1 : null);
  $linenum = isset($linenum) ? "linenum='$linenum'" : '';
  $highlight = isset($opt['highlight']) ? $opt['highlight'] : null;
  $highlight = isset($highlight) ? "highlight='$highlight'" : '';

  return Keep(CodeMirrorBlock($pagename, "'$spec' $linenum $highlight", $m[4]));
}
